
<!-- (SPDX-License-Identifier: CC-BY-4.0) -->  <!-- Ensure there is a newline before, and after, this line -->

## New Features

 * Dockerizing Hyperledger Explorer

 * Search blocks, and transactions by date range, and organizations

 * JSON Pretty Print

 * ESLint Rules

 * Support Hyperledger Cello project

 * Database setup using pgconfig.json properties


## Bug Fixes and Updates

 * User Interface improvements, input controls, navigational, and informational components

 * Theme Refactoring

 * DDL updates

 * Metrics charts inconsistency

 * Swagger updates


## Known Vulnerabilities

    Low           │ Prototype Pollution
    Package       │ deepextend
    Dependency of │ fabricclient
    Path          │ fabricclient > grpc > nodepregyp > rc > deepextend
    More info     │ https://nodesecurity.io/advisories/612

    Moderate      │ Outofbounds Read
    Package       │ stringstream
    Dependency of │ fabricclient
    Path          │ fabricclient > grpc > nodepregyp > request > stringstream
    More info     │ https://nodesecurity.io/advisories/664

    High          │ Open Redirect
    Package       │ url - parse
    Dependency of │ react - scripts
    Path          │ react - scripts > react - dev - utils > sockjs - client >
    │ eventsource > original > url - parse
    More info     │ https://nodesecurity.io/advisories/678

    High          │ Open Redirect
    Package       │ url - parse
    Dependency of │ react - scripts
    Path          │ react - scripts > webpack - dev - server > sockjs - client >
    │ eventsource > original > url - parse
    More info     │ https://nodesecurity.io/advisories/678

    High          │ Open Redirect
    Package       │ url - parse
    Dependency of │ react - scripts
    Path          │ react - scripts > webpack - dev - server > sockjs - client >
    │ url - parse
    More info     │ https://nodesecurity.io/advisories/678

    High          │ Open Redirect
    Package       │ url - parse
    Dependency of │ react - scripts
    Path          │ react - scripts > react - dev - utils > sockjs - client > url - parse
    More info     │ https://nodesecurity.io/advisories/678


## Resolved Vulnerabilities

 * All above fixed, steps to fix:
    $`npm i npm@latest -g`
    $`npm audit fix`
